using System;

namespace ConsoleApp17
{
   
    class Program
    {
        static public void Main()
        {
            int n = int.Parse(Console.ReadLine());
            string[] split = Console.ReadLine().Split();
            int o = int.Parse(split[0]);
            int a = int.Parse(split[1]);
            int b = int.Parse(split[2]);
            int ab = int.Parse(split[3]);
            int nemogucnost=0;
            Console.WriteLine("moguce");
            for (int i = 0; i < n; i++)
            {
                int kolikodato = 0;
                int kolikodatoA = 0;
                int kolikodatoB = 0;
                int kolikodatoAB = 0;
                string[] splita = Console.ReadLine().Split();
                string grupa = splita[0];
                int jedinicaKrviKojeSuPotrebne = int.Parse(splita[1]);
                if (grupa=="O")
                {
                    if (o>=jedinicaKrviKojeSuPotrebne)
                    {
                        kolikodato = jedinicaKrviKojeSuPotrebne;
                        o = o - jedinicaKrviKojeSuPotrebne;
                        
                    }
                    else 
                    {
                        nemogucnost++;
                    }
                }
                else if(grupa == "A")
                {
                    if (a >= jedinicaKrviKojeSuPotrebne)
                    {
                        kolikodatoA = jedinicaKrviKojeSuPotrebne;
                        a = a - jedinicaKrviKojeSuPotrebne;
                    }
                    else 
                    {
                        if (a != 0)
                        {
                            kolikodatoA = a;
                            if (o+a >= jedinicaKrviKojeSuPotrebne)
                            {
                                kolikodato = jedinicaKrviKojeSuPotrebne-a;
                                o = o - (jedinicaKrviKojeSuPotrebne-a);

                            }
                            else
                            {
                                nemogucnost++;
                            }
                            a = 0;
                        }
                        else if (o!=0)
                        {
                            if (o >= jedinicaKrviKojeSuPotrebne)
                            {
                                kolikodato = jedinicaKrviKojeSuPotrebne;
                                o = o - jedinicaKrviKojeSuPotrebne;

                            }
                            else
                            {
                                nemogucnost++;
                            }
                        }
                        else
                        {
                            nemogucnost++;
                        }
                    }
                }
                else if (grupa == "B")
                {
                    if (b >= jedinicaKrviKojeSuPotrebne)
                    {
                        kolikodatoB = jedinicaKrviKojeSuPotrebne;
                        b = b - jedinicaKrviKojeSuPotrebne;
                    }
                    else
                    {
                        if (b != 0)
                        {
                            kolikodatoB = b;
                            if (o + b >= jedinicaKrviKojeSuPotrebne)
                            {
                                kolikodato = jedinicaKrviKojeSuPotrebne - b;
                                o = o - (jedinicaKrviKojeSuPotrebne - b);

                            }
                            else
                            {
                                nemogucnost++;
                            }
                            b = 0;
                        }
                        else if (o != 0)
                        {
                            if (o >= jedinicaKrviKojeSuPotrebne)
                            {
                                kolikodato = jedinicaKrviKojeSuPotrebne;
                                o = o - jedinicaKrviKojeSuPotrebne;

                            }
                            else
                            {
                                nemogucnost++;
                            }
                        }
                        
                    }
                }
            
                 Console.WriteLine("{0} {1} {2} {3}", kolikodato, kolikodatoA, kolikodatoB, kolikodatoAB); 
            }
            
        }
    }
}